
%define udevrulesdir /lib/udev/rules.d

%define major 2
%define libname %mklibname drm %{major}
%define develname %mklibname drm -d

%define intel_major 1
%define libintel %mklibname drm_intel %{intel_major}
%define nouveau_major 1
%define libnouveau %mklibname drm_nouveau %{nouveau_major}
%define radeon_major 1
%define libradeon %mklibname drm_radeon %{radeon_major}
%define tegra_major 0
%define libtegra %mklibname drm_tegra %{tegra_major}
%define omap_major 1
%define libomap %mklibname drm_omap %{omap_major}
%define etnaviv_major 1
%define libetnaviv %mklibname drm_etnaviv %{etnaviv_major}
%define exynos_major 1
%define libexynos %mklibname drm_exynos %{exynos_major}
%define freedreno_major 1
%define libfreedreno %mklibname drm_freedreno %{freedreno_major}
%define amdgpu_major 1
%define libamdgpu %mklibname drm_amdgpu %{amdgpu_major}

%define bcond_meson() %{lua: do
  local option = rpm.expand("%{1}")
  local with = rpm.expand("%{?with_" .. option .. "}")
  local value = (with ~= '') and "enabled" or "disabled"
  option = option:gsub('_', '-')
  print(string.format("-D%s=%s", option, value))
end}

%define bcond_meson_bool() %{lua: do
  local option = rpm.expand("%{1}")
  local with = rpm.expand("%{?with_" .. option .. "}")
  local value = (with ~= '') and "true" or "false"
  option = option:gsub('_', '-')
  print(string.format("-D%s=%s", option, value))
end}

%bcond_without intel
%bcond_without radeon
%bcond_without amdgpu
%bcond_without nouveau
%bcond_without vmwgfx
%bcond_with    omap
%bcond_with    exynos
%bcond_with    freedreno
%bcond_with    tegra
%bcond_with    vc4
%bcond_with    etnaviv
%bcond_with    cairo_tests
%bcond_without man_pages
%bcond_with    valgrind
%bcond_with    freedreno_kgsl
%bcond_without install_test_programs
%bcond_without udev

Name:		libdrm
Summary:    Direct Rendering Manager runtime library
Version:	2.4.120
Release:	%mkrel 1
License:    MIT
Group:		System/Libraries
URL:		http://xorg.freedesktop.org
Source0:	https://dri.freedesktop.org/libdrm/libdrm-%{version}.tar.xz
Source2:	91-drm-modeset.rules

BuildRequires:  meson
BuildRequires:  pkgconfig 
BuildRequires:  automake 
BuildRequires:  autoconf 
BuildRequires:  libtool
BuildRequires:	kernel-userspace-headers
BuildRequires:	libpthread-stubs
BuildRequires:	x11-util-macros
BuildRequires:	lib64pciaccess-devel
BuildRequires:	lib64cairo-devel
BuildRequires:	xsltproc
BuildRequires:	docbook-xsl
BuildRequires:	lib64cunit-devel
BuildRequires:	lib64udev0-devel
BuildRequires:	python3-docutils
BuildRequires: python-docutils
# Upstream fixes
# from https://gitlab.freedesktop.org/mesa/drm
Patch0001:	0001-amdgpu-add-marketing-names-from-Adrenalin-23.11.1.patch
Patch0002:	0002-amdgpu-add-marketing-names-from-PRO-Edition-for-W770.patch
Patch0003:	0003-amdgpu-add-marketing-names-from-Windows-Steam-Deck-O.patch
Patch0004:	0004-amdgpu-add-marketing-names-from-amd-6.0.patch
Patch0005:	0005-amdgpu-add-marketing-name-for-Radeon-RX-6550M.patch
Patch0006:	0006-amdgpu-add-marketing-names-from-amd-6.0.1.patch
Patch0007:	0007-xf86drm-ignore-symlinks-in-process_device.patch
Patch0008:	0008-Revert-xf86drm-ignore-symlinks-in-process_device.patch
Patch0009:	0009-xf86drm-Don-t-consider-node-names-longer-than-the-ma.patch
Patch0010:	0010-meson-make-build-system-happy-by-replacing-deprecate.patch
Patch0011:	0011-tests-util-add-tidss-driver.patch
Patch0012:	0012-amdgpu-Make-amdgpu_device_deinitialize-thread-safe.patch
Patch0013:	0013-amdgpu-add-amdgpu_va_manager.patch
Patch0014:	0014-amdgpu-expose-amdgpu_va_manager-publicly.patch
Patch0015:	0015-amdgpu-add-amdgpu_va_range_alloc2.patch
Patch0016:	0016-amdgpu-add-amdgpu_device_initialize2.patch
Patch0017:	0017-symbols-check-Add-_GLOBAL_OFFSET_TABLE_.patch
Patch0018:	0018-symbols-check-Add-_fbss-_fdata-_ftext.patch
Patch0019:	0019-amdgpu-fix-deinit-logic.patch
Patch0020:	0020-meson-Replace-usages-of-deprecated-ExternalProgram.p.patch
Patch0021:	0021-meson-Fix-broken-str.format-usage.patch



Patch1001:	libdrm-make-dri-perms-okay.patch
Patch1002:	libdrm-2.4.69-no-bc.patch
Patch0500:	0500-improve-waiting-for-dri-device-to-appear-when-system.patch

%description
Direct Rendering Manager runtime library

%package common
Summary:	Common files for the userspace interface to kernel DRM services
Group:		System/Libraries
Obsoletes: lib64kms1

%description common
Common files for the userspace interface to kernel DRM services

%package -n	%{libname}
Summary:	Userspace interface to kernel DRM services
Group:		System/Libraries
Provides:	%{name} = %{version}
Requires:   %{name}-common
Requires:   drm-utils
Requires:	%{libintel} = %{version}
Requires:	%{libnouveau} = %{version}
Requires:	%{libradeon} = %{version}
Requires:	%{libamdgpu} = %{version}

%description -n	%{libname}
Userspace interface to kernel DRM services

%package -n	%{libintel}
Summary:	Shared library for Intel kernel DRM services
Group:		System/Libraries

%description -n %{libintel}
Shared library for Intel kernel Direct Rendering Manager services.

%package -n	%{libnouveau}
Summary:	Shared library for Nouveau kernel DRM services
Group:		System/Libraries

%description -n %{libnouveau}
Shared library for Nouveau kernel Direct Rendering Manager services.

%package -n	%{libradeon}
Summary:	Shared library for Radeon kernel DRM services
Group:		System/Libraries

%description -n %{libradeon}
Shared library for Radeon kernel Direct Rendering Manager services.

%package -n	%{libamdgpu}
Summary:	Shared library for AMDGPU kernel DRM services
Group:		System/Libraries

%description -n %{libamdgpu}
Shared library for AMDGPU kernel Direct Rendering Manager services.

%package -n	%{develname}
Summary:    Direct Rendering Manager development package
Group:		Development/Libraries
Requires:	%{libname} = %{version}
Requires:	%{libintel} = %{version}
Requires:	%{libnouveau} = %{version}
Requires:	%{libradeon} = %{version}
Requires:	%{libamdgpu} = %{version}
Provides:   %{name}-devel = %{version}-%{release}

%description -n	%{develname}
Direct Rendering Manager development package.

%package -n drm-utils
Summary:    Direct Rendering Manager utilities
Group:		System/Base
Requires:   %{libname} = %{version}-%{release}

%description -n drm-utils
Utility programs for the kernel DRM interface.

%prep
%setup -q
%autopatch -p1

%build

export CFLAGS="$CFLAGS -pipe -ffast-math"
export CXXFLAGS="$CXXFLAGS -pipe -ffast-math"

#fix library for our old plymouth link
sd "2.0.0" "1.0.0" nouveau/meson.build

%meson \
  %{bcond_meson intel}                 \
  %{bcond_meson radeon}                \
  %{bcond_meson amdgpu}                \
  %{bcond_meson nouveau}               \
  %{bcond_meson vmwgfx}                \
  %{bcond_meson omap}                  \
  %{bcond_meson exynos}                \
  %{bcond_meson freedreno}             \
  %{bcond_meson tegra}                 \
  %{bcond_meson vc4}                   \
  %{bcond_meson etnaviv}               \
  %{bcond_meson cairo_tests}           \
  %{bcond_meson man_pages}             \
  %{bcond_meson valgrind}              \
  %{bcond_meson_bool freedreno_kgsl}   \
  %{bcond_meson_bool install_test_programs} \
  %{bcond_meson_bool udev}             \
  %{nil}
%meson_build

%install
%meson_install
install -Dpm0755 -t %{buildroot}%{_bindir} %{_vpath_builddir}/tests/drmdevice
%if %{with udev}
install -Dpm0644 -t %{buildroot}%{_udevrulesdir} %{S:2}
%endif

# NOTE: We intentionally don't ship *.la files
find %{buildroot} -type f -name "*.la" -delete

# (cg) Note that RH remove r300_reg.h via_3d_reg.h
# and we should perhaps do the same? (previous attempts have not gone well :)

%files common
%{_udevrulesdir}/91-drm-modeset.rules
%{_datadir}/libdrm/amdgpu.ids

%files -n %{libname}
%{_libdir}/libdrm.so.%{major}*

%files -n %{libintel}
%{_libdir}/libdrm_intel.so.%{intel_major}*

%files -n %{libnouveau}
%{_libdir}/libdrm_nouveau.so.%{nouveau_major}*

%files -n %{libamdgpu}
%{_libdir}/libdrm_amdgpu.so.%{amdgpu_major}*

%files -n %{libradeon}
%{_libdir}/libdrm_radeon.so.%{radeon_major}*

%files -n drm-utils
%{_bindir}/amdgpu_stress
%{_bindir}/amdgpu_test
%{_bindir}/drmdevice
%{_bindir}/modetest
%{_bindir}/modeprint
%{_bindir}/vbltest
%{_bindir}/proptest

%files -n %{develname}
%{_includedir}/libdrm
%{_includedir}/*.h
%{_libdir}/libdrm*.so
%{_libdir}/pkgconfig/libdrm*.pc
%{_mandir}

%changelog
* Tue Apr 02 2024 tex - 2.4.120-1pclos2024
- new version


* Sun Dec 24 2023 tex - 2.4.119-1pclos2024
- new version

* Wed Oct 25 2023 tex - 2.4.117-1pclos2023
- new version

* Thu Aug 24 2023 tex - 2.4.116-1pclos2023
- new version

* Fri Feb 10 2023 tex - 2.4.115-1pclos2023
- new version

* Sat Nov 05 2022 tex - 2.4.114-1pclos2022
- new version

* Tue Oct 04 2022 tex - 2.4.113-2pclos2022
- apply new patches

* Sun Sep 04 2022 tex - 2.4.113-1pclos2022
- new version

* Wed Jul 06 2022 tex - 2.4.112-1pclos2022
- new version

* Thu Feb 17 2022 tex - 2.4.110-1pclos2022
- new version

* Sat Nov 27 2021 tex - 2.4.109-1pclos2021
- new version

* Wed Nov 17 2021 tex - 2.4.108-2pclos2021
- radeon: remove duplicate declaration of struct radeon_bo_manager in radeon_bo.h

* Tue Nov 09 2021 tex - 2.4.108-1pclos2021
- new version

* Fri Jul 02 2021 tex- 2.4.107-1pclos2021
- sync to le france

* Fri Jun 18 2021 tex - 2.4.106-3pclos2021
- sync to le france

* Fri May 21 2021 tex - 2.4.106-2pclos2021
- sync to france
